{ File Encryptor / Decryptor
  (C) 2006-2012, Andreas Berg. All Rights Reserved. }
program encrypt;

uses
 Crt, Sysutils, _ecommon, _ecrypt, _pbar;

const
 CurVer            = '0.01';

var
 i                 : integer;
 s                 : string;
 err               : boolean;
 f                 : boolean;
 pOK               : boolean;



function ReadPass: string;
var
 p                 : string;
 c                 : char;
 x, y              : integer;
begin
   p:= '';
   while true do begin
      repeat
      until keypressed;
      c:= ReadKey;
      if c = #13 then break;
      if c = #8 then begin
         if p <> '' then begin
            x:= WhereX;
            y:= WhereY;
            p:= copy(p, 1, length(p)-1);
            if x = 1 then begin
               dec(y);
               x:= 81;
            end;
            gotoxy(x-1, y);
            Write(' ');
            gotoxy(x-1, y);
         end;
      end else begin
         Write('*');
         p:= p + c;
      end;
   end;
   WriteLn('');
   ReadPass:= p;
end;



begin
   Write('File Encryptor ' + CurVer);
   WriteLn(' / (C) 2006-2012, Andreas Berg. All Rights Reserved.');

   if ParamCount = 0 then begin
      WriteLn('usage:  encrypt  input-file  [options]  [output-file]');
      WriteLn('');
      WriteLn('OPTION              DESCRIPTION');
      Writeln(' -p:<password>      Set Password');

      Writeln('');
   end else begin
      WriteLn('');
      CmdIFile:= '';
      CmdOFile:= '';
      CmdPwd:= '';
      err:= false;

      for i:= 1 to ParamCount do begin
         s:= ParamStr(i);
         if s[1] = '-' then begin
            f:= false;
            if UpperCase(copy(s, 1, 3)) = '-P:' then begin
               CmdPwd:= copy(s, 4, length(s) - 3);
               f:= true;
            end;

            if not f then begin
               Writeln('ERROR: Invalid option [' + s + ']!');
               err:= true;
            end;
         end else begin
            if CmdIFile = '' then
             CmdIFile:= ParamStr(i)
            else begin
               if CmdOFile = '' then
                CmdOFile:= ParamStr(i)
               else begin
                  Writeln('ERROR: Input and Output files already set!');
                  err:= true;
               end;
            end;
         end;
      end;

      if not err then begin
         if FileExists(CmdIFile) then begin
            if CmdOFile = '' then begin
               CmdOFile:= RemoveExt(CmdIFile) + '.bef';
            end;

            if UpperCase(CmdIFile) <> UpperCase(CmdOFile) then begin
               sfile:= CmdIFile;
               efile:= CmdOFile;

               pOK:= true;
               if CmdPwd = '' then begin
                  Write('Set Password   : ');
                  CmdPwd:= ReadPass;
                  if CmdPwd <> '' then begin
                     Write('Verify Password: ');
                     s:= ReadPass;
                     if CmdPwd <> s then begin
                        WriteLn('ERROR: Passwords does not match!');
                        pOK:= false;
                     end;
                  end;
                  WriteLn('');
               end;

               if pOK then begin
                  Write('Encrypting: ');
                  BarX:= WhereX;
                  BarY:= WhereY;

                  IsRunEnc:= true;
                  RunEncrypt;

                  Writeln;
                  WriteLn('');
                  WriteLn('*** DONE ***');
                  WriteLn('');
               end;
            end else begin
               Writeln('ERROR: Input-File and Output-File match!');
            end;
         end else begin
            if CmdIFile <> '' then
             WriteLn('ERROR: File not found [' + CmdIFile + ']!')
            else
             WriteLn('ERROR: No File to encrypt!');
         end;
      end;

   end;
end.

